std::filesystem::path::c_str,std::filesystem::path::native,(3)

NAME
std::filesystem::path::c_str,std::filesystem::path::native, - std::filesystem::path::c_str,std::filesystem::path::native,

Synopsis
   const value_type* c_str() const noexcept; (1) (since C++17)
   const string_type& native() const noexcept; (2) (since C++17)
   operator string_type() const; (3) (since C++17)
   Accesses the native path name as a character string.
   1) Equivalent to native().c_str().
   2) Returns the native-format representation of the pathname by reference.
   3) Returns the native-format representation of the pathname by value.

Parameters
   (none)

Return value
   The native string representation of the pathname, using native syntax, native
   character type, and native character encoding. This string is suitable for use with
   OS APIs.

Notes
   The conversion function (3) is provided so that APIs that accept std::basic_string
   file names can use pathnames with no changes to code.

Example
// Run this code
 #include <cstdio>
 #ifdef _MSC_VER
 #include <io.h>
 #include <fcntl.h>
 #else
 #include <locale>
 #include <clocale>
 #endif
 #include <fstream>
 #include <filesystem>
 int main()
 {
 #ifdef _MSC_VER
     _setmode(_fileno(stderr), _O_WTEXT);
 #else
     std::setlocale(LC_ALL, "");
     std::locale::global(std::locale(""));
 #endif
     std::filesystem::path p(u8"要らない.txt");
     std::ofstream(p) << "File contents"; // Prior to LWG2676 uses operator string_type()
                        // on MSVC, where string_type is wstring, only
                        // works due to non-standard extension.
                        // Post-LWG2676 uses new fstream constructors
     // native string representation can be used with OS APIs
     if (std::FILE* f =
 #ifdef _MSC_VER
                 _wfopen(p.c_str(), L"r")
 #else
                 std::fopen(p.c_str(), "r")
 #endif
         )
     {
         int ch;
         while((ch=fgetc(f)) != EOF) putchar(ch);
         std::fclose(f);
     }
     std::filesystem::remove(p);
 }

Possible output:
 File contents

See also
   string
   wstring returns the path in native pathname format converted to a string
   u8string (public member function)
   u16string
   u32string
   generic_string
   generic_wstring returns the path in generic pathname format converted to a string
   generic_u8string (public member function)
   generic_u16string
   generic_u32string